# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`mq_install::installmq`](#mq_installinstallmq): Deprecated; Please the ibm_profile module.
* [`mq_install::os`](#mq_installos): Deprecated; Please the ibm_profile module.
* [`mq_install::software`](#mq_installsoftware): This class install's specified version of the the MQ software on the system.

### Defined types

* [`mq_install::autostart`](#mq_installautostart): The defined type `mq_install::autostart` allows you to create a systemd startup unit for a specified MQ queue manager and
* [`mq_install::software::unix`](#mq_installsoftwareunix): This class install's specified version of the the MQ software for Unix like systems on the system.
* [`mq_install::software::windows`](#mq_installsoftwarewindows): This class install's specified version of the the MQ software for Windows on the system.

### Resource types

* [`mq_install`](#mq_install): Setup the MQ installer.

### Functions

* [`mq_install::fixpack_downgrade`](#mq_installfixpack_downgrade): Function to determine if we need a fixpack downgrade. We do this based on the current version and the requested version
* [`mq_install::fixpack_upgrade`](#mq_installfixpack_upgrade): Function to determine if we need a fixpack upgrade. We do this based on the current version and the requested version
* [`mq_install::running_managers`](#mq_installrunning_managers): Function to fetch the fact mq_managers and based on that information decide if the specfied queue manager is running in standby mode or not.
* [`mq_install::selected_components`](#mq_installselected_components): Create array of selected components based on the selection.  rubocop:disable all
* [`mq_install::validate_selection`](#mq_installvalidate_selection): Fetch the OS specifc settings and validate if the selected components can be installed here.  rubocop:disable all
* [`mq_install::version_upgrade`](#mq_installversion_upgrade): Function to determine if we are changing to version with a different major or minor version.

### Tasks

* [`restart`](#restart): Restart the specified MQ queue manager on the specified node
* [`start`](#start): Startup the specified MQ queue manager on the specified node
* [`status`](#status): Fetch the status of the specified MQ queue manager on the specified node
* [`stop`](#stop): Shutdown the specified MQ queue manager on the specified node

### Plans

* [`mq_install::apply_fixpack`](#mq_installapply_fixpack): Apply the in hiera specified MQ fixpack to the specified nodes.
* [`mq_install::apply_upgrades`](#mq_installapply_upgrades): Apply the in hiera specified MQ upgrades to the specified nodes.

## Classes

### <a name="mq_installinstallmq"></a>`mq_install::installmq`

mq_install::installmq

**This class is deprecated.** The best thing, is to use the [mq_machine class from the ibm_profile module](/docs/ibm_profile/description.html#the-ibm_profilemq_machine-class). the [ibm_profile module](/docs/ibm_profile/description.html#the-ibm_profilemq_machine-class) contains several steps that you can use to customize your OS setup as needed for MQ.

## Old documentation

The class `mq_install::installmq` is a convenience class that allows you to install a specific version of the IBM MQ software on your system. Because MQ only allows you to install one version, this class also only supports installing one version.

Here is an example on how to use it:

``` puppet
include mq_install::installmq
```

This class is parameterless, but it calls the [`mq_install::os`](docs/mq_install/os.html) and [`mq_install::software`](docs/mq_install/software.html) classes. Those parameters can be set using hiera.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `mq_install::installmq` class:

* [`title`](#title)

##### <a name="title"></a>`title`

The name of the class.

### <a name="mq_installos"></a>`mq_install::os`

mq_install::os

**This class is deprecated.** The best thing, is to use the [ibm_profile module](https://forge.puppet.com/modules/enterprisemodules/ibm_profile). The [ibm_profile module](https://forge.puppet.com/modules/enterprisemodules/ibm_profile) contains several steps that you can use to customize your OS setup as needed for MQ.

## Old documentation

The `mq_install::os` defined type is a convenience class for adding the MQ users and setting the MQ OS requirements on your system.

class mq_install::os(
  Easy_type::Password $mqm_password,
)

Here is an example on how to use it:

``` puppet
class { 'mq_install::os':
  mqm_password    => Sensitive('verysecret'),
}
```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `mq_install::os` class:

* [`mqm_password`](#mqm_password)
* [`managehome`](#managehome)
* [`nofile`](#nofile)
* [`nproc`](#nproc)
* [`shmall`](#shmall)
* [`shmmax`](#shmmax)
* [`shmmni`](#shmmni)
* [`overcommit_memory`](#overcommit_memory)
* [`overcommit_ratio`](#overcommit_ratio)
* [`threads_max`](#threads_max)
* [`pid_max`](#pid_max)
* [`file_max`](#file_max)

##### <a name="mqm_password"></a>`mqm_password`

Data type: `Easy_type::Password`

The password to be used for the `mqm` user.
The default is the same as the username.
Here is an example on how to use this:
    class { '::mq_install::os':
      ...
      mqm_password => Sensitive('secret'),
      ...
    }

##### <a name="managehome"></a>`managehome`

Data type: `Boolean`

Allows you to specify whether you want to manage the MQM users home dir.
By default this is set to true and it will create a home directory for
the MQM user named '/var/mqm'.
When you want to use an other folder, set the value of `managehome` to false
and create your own links from '/var/mqm' to the directories you want.
Here is an example on how to use this:
    class { '::mq_install::os':
      ...
      managehome => false,
      ...
    }

Default value: ``true``

##### <a name="nofile"></a>`nofile`

Data type: `Integer`



##### <a name="nproc"></a>`nproc`

Data type: `Integer`



##### <a name="shmall"></a>`shmall`

Data type: `Integer`



##### <a name="shmmax"></a>`shmmax`

Data type: `Integer`



##### <a name="shmmni"></a>`shmmni`

Data type: `Integer`



##### <a name="overcommit_memory"></a>`overcommit_memory`

Data type: `Integer`



##### <a name="overcommit_ratio"></a>`overcommit_ratio`

Data type: `Integer`



##### <a name="threads_max"></a>`threads_max`

Data type: `Integer`



##### <a name="pid_max"></a>`pid_max`

Data type: `Integer`



##### <a name="file_max"></a>`file_max`

Data type: `Integer`



### <a name="mq_installsoftware"></a>`mq_install::software`

mq_install::software

The source zip file from IBM is found at the location specified at `source_location`. By default it will install only the minimal required set. By using the `install_...` parameters, you can install optional components.

Here is an example on how to use it:

``` puppet
class { '::mq_install::software':
  source_location  => '/software',
  version          => '9.0.0.0'
  tmp_dir          => '/tmp'
  install_ams      => true,
  install_ft       => false,
  install_client   => false,
  install_explorer => true,
  install_xrserver => false,
  install_samples  => false,
  install_sdk      => false,
  install_man      => false,
  install_gskit    => false,
  install_amqp     => false,
  logoutput        => 'true,
}
```

On systems with a secured `/tmp` direcory, you MUST specify the `tmp_dir` parameter and specify a directory that puppet is allowed to execute scripts from. It must also have enough space to receive the extracted MQ installation kit.

## MQ Upgrade

When you specify a version where either the major or the minor version is higher than the currently installed version, Puppet will detect this and start the upgrade scenario. The upgrade scenario consists of:

1) Shutting down all running queue managers
2) Uninstalling current MQ version packages, including any installed fixpacks
3) Installing the requested version

**WARNING** The `mq_install::software` class does **not** automaticaly restart the queue managers again. In general, this is taken care of by `ora_install::autostart`. If `ora_install::autostart` is not part of your manifest you must ensure your own steps to make sure the queue managers are restarted again.
## MQ Downgrade

When you specify a version where either the major or the minor version is lower then the currently installed version, Puppet will detect this. Unfortunately, MQ does not support this without manually restoring some files. Therefore Puppet will give you an error.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `mq_install::software` class:

* [`source_location`](#source_location)
* [`service_window`](#service_window)
* [`version`](#version)
* [`file_name`](#file_name)
* [`tmp_dir`](#tmp_dir)
* [`install_ams`](#install_ams)
* [`install_ft`](#install_ft)
* [`install_client`](#install_client)
* [`install_explorer`](#install_explorer)
* [`install_xrserver`](#install_xrserver)
* [`install_samples`](#install_samples)
* [`install_sdk`](#install_sdk)
* [`install_man`](#install_man)
* [`install_gskit`](#install_gskit)
* [`install_amqp`](#install_amqp)
* [`install_web`](#install_web)
* [`install_salesforce`](#install_salesforce)
* [`install_blockchain`](#install_blockchain)
* [`install_rdqm`](#install_rdqm)
* [`install_toolkit`](#install_toolkit)
* [`supported_components`](#supported_components)
* [`supported_major_versions`](#supported_major_versions)
* [`logoutput`](#logoutput)

##### <a name="source_location"></a>`source_location`

Data type: `String[1]`

The location of the MQ software.
Here is an example on how to use this:
    class { '::mq_install::...':
      ...
      source_location => '/software',
      ...
    }

##### <a name="service_window"></a>`service_window`

Data type: `String[1]`

The service_window Puppet will use to execute a specified upgrade.
When Puppet detects a mismatch between the current version and the version in your manifest, it will start to execute an upgrade. But in
general, you want some control over when that happens. You don't want Puppet to stop your queue managers during regular production hours to do the upgrade.
The `service_window` parameter allows this control. The parameter can have the following values:
- DIRECT
- INSTALL_ONLY
- A time range
## DIRECT
`DIRECT` is the normal behavior of Puppet (e.g., **not** the default of the parameter). When a manifest change is detected, Puppet will immediately execute the upgrade and, in this process, stop the MQ queue managers.
## INSTALL_ONLY
This is the default value for this class. In this case, Puppet will use the specified manifest values **ONLY** on an initial install. When Puppet detects MQ is already running, it will leave it like it is and **NOT** do the upgrade. You can use, for example, a bolt plan or task to execute the upgrade at a moment that suits your requirements.
## time range
When you have a specific service window wherein Puppet **is** allowed to do the MQ shutdown and execute the upgrade procedure, you can specify a time range. An example of a time range would be: '01:00 - 02:00`

Default value: `'INSTALL_ONLY'`

##### <a name="version"></a>`version`

Data type: `Pattern[/\d+\.\d+\.\d+\.\d/]`

The version to be installed.
Here is an example on how to use this:
    class { '::mq_install::software':
      ...
      version => '9.0.0.0',
      ...
    }

##### <a name="file_name"></a>`file_name`

Data type: `Optional[String[1]]`

The file containing the install kit for the MQ software.

Default value: ``undef``

##### <a name="tmp_dir"></a>`tmp_dir`

Data type: `String[1]`

This defined type uses a temporary directory.
By default this is `\tmp`. If you want to use an other directory for this, you must specify this parameter.
Here is an example on how to use this:
    class { '::mq_install::...':
      ...
      tmp_dir => '/my_tmp_dir',
      ...
    }
On systems with a secured `/tmp` direcory, you MUST specify the `tmp_dir` parameter and specify a directory that puppet is allowed to execute scripts from. It must also have enough space to receive the extracted MQ installation kit.

Default value: `'/tmp'`

##### <a name="install_ams"></a>`install_ams`

Data type: `Boolean`

Specify a value of `true` when you want to install this component.
Here is an example:
    class { '::mq_install::software':
      ...
      install_ams => true,
      ...
    }
The default is 'false'. Meaning this component is not installed.

Default value: ``false``

##### <a name="install_ft"></a>`install_ft`

Data type: `Boolean`

Specify a value of `true` when you want to install this component.
Here is an example:
    class { '::mq_install::software':
      ...
      install_ft => true,
      ...
    }
The default is 'false'. Meaning this component is not installed.

Default value: ``false``

##### <a name="install_client"></a>`install_client`

Data type: `Boolean`

Specify a value of `true` when you want to install this component.
Here is an example:
    class { '::mq_install::software':
      ...
      install_client => true,
      ...
    }
The default is 'false'. Meaning this component is not installed.

Default value: ``false``

##### <a name="install_explorer"></a>`install_explorer`

Data type: `Boolean`

Specify a value of `true` when you want to install this component.
Here is an example:
    class { '::mq_install::software':
      ...
      install_explorer => true,
      ...
    }
The default is 'false'. Meaning this component is not installed.

Default value: ``false``

##### <a name="install_xrserver"></a>`install_xrserver`

Data type: `Boolean`

Specify a value of `true` when you want to install this component.
Here is an example:
    class { '::mq_install::software':
      ...
      install_xserver => true,
      ...
    }
The default is 'false'. Meaning this component is not installed.

Default value: ``false``

##### <a name="install_samples"></a>`install_samples`

Data type: `Boolean`

Specify a value of `true` when you want to install this component.
Here is an example:
    class { '::mq_install::software':
      ...
      install_samples => true,
      ...
    }
The default is 'false'. Meaning this component is not installed.
This component can only be installed on Linux systems.

Default value: ``false``

##### <a name="install_sdk"></a>`install_sdk`

Data type: `Boolean`

Specify a value of `true` when you want to install this component.
Here is an example:
    class { '::mq_install::software':
      ...
      install_sdk => true,
      ...
    }
The default is 'false'. Meaning this component is not installed.
This component can only be installed on Linux systems.

Default value: ``false``

##### <a name="install_man"></a>`install_man`

Data type: `Boolean`

Specify a value of `true` when you want to install this component.
Here is an example:
    class { '::mq_install::software':
      ...
      install_man => true,
      ...
    }
The default is 'false'. Meaning this component is not installed.
This component can only be installed on Linux systems.

Default value: ``false``

##### <a name="install_gskit"></a>`install_gskit`

Data type: `Boolean`

Specify a value of `true` when you want to install this component.
Here is an example:
    class { '::mq_install::software':
      ...
      install_gskit => true,
      ...
    }
The default is 'false'. Meaning this component is not installed.
This component can only be installed on Linux systems.

Default value: ``false``

##### <a name="install_amqp"></a>`install_amqp`

Data type: `Boolean`

Specify a value of `true` when you want to install this component.
Here is an example:
    class { '::mq_install::software':
      ...
      install_amqp => true,
      ...
    }
The default is 'false'. Meaning this component is not installed.

Default value: ``false``

##### <a name="install_web"></a>`install_web`

Data type: `Boolean`

Specify a value of `true` when you want to install this component.
Here is an example:
    class { '::mq_install::software':
      ...
      install_web => true,
      ...
    }
The default is 'false'. Meaning this component is not installed.

Default value: ``false``

##### <a name="install_salesforce"></a>`install_salesforce`

Data type: `Boolean`

Specify a value of `true` when you want to install the Bridge to Salesforce component.
Here is an example:
    class { '::mq_install::software':
      ...
      install_salesforce => true,
      ...
    }
The default is 'false'. Meaning this component is not installed.
Install this component to configure the connections to Salesforce and IBM MQ, then run the runmqsfb command to subscribe to events from Salesforce and publish them to an IBM MQ network.
This component can only be installed on Linux systems.

Default value: ``false``

##### <a name="install_blockchain"></a>`install_blockchain`

Data type: `Boolean`

Specify a value of `true` when you want to install the IBM MQ Bridge to blockchain component.
Here is an example:
    class { '::mq_install::software':
      ...
      install_blockchain => true,
      ...
    }
The default is 'false'. Meaning this component is not installed.
Install this component to configure the connections to your blockchain network and IBM MQ. You can then run the runmqbcb command to start the bridge and send queries and updates to, and receive responses from your blockchain network. The queue manager that the bridge connects to must be an IBM MQ Advanced queue manager.
This component is available only on Linux for System x (64 bit), on RHEL 7.3 or later and is only supported for MQ 9.1 and higher.
This component can only be installed on Linux systems.

Default value: ``false``

##### <a name="install_rdqm"></a>`install_rdqm`

Data type: `Boolean`

Specify a value of `true` when you want to install the replicated data queue manager component.
Here is an example:
    class { '::mq_install::software':
      ...
      install_rqdm => true,
      ...
    }
The default is 'false'. Meaning this component is not installed.
Install this component to make the replicated data queue manager high availability configuration available. See Installing RDQM (replicated data queue managers) for more information.
This component is available only on Linux for System x (64 bit), on RHEL 7.3 or later and is only supported for MQ 9.1 and higher.
This component can only be installed on Linux systems.

Default value: ``false``

##### <a name="install_toolkit"></a>`install_toolkit`

Data type: `Boolean`

Specify a value of `true` when you want to install this component.
Here is an example:
    class { '::mq_install::software':
      ...
      install_toolkit => true,
      ...
    }
The default is 'false'. Meaning this component is not installed.
This component can only be installed on Windows systems.

Default value: ``false``

##### <a name="supported_components"></a>`supported_components`

Data type: `Hash`



##### <a name="supported_major_versions"></a>`supported_major_versions`

Data type: `Array[String[1]]`

The major versions of MQ supported by this class.

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[Enum['on_failure'], Boolean]`

If you want to see the output of the `exec` resources in the type, you can set this value to `true`.
The default is `on_failure`.
Here is an example on how to use this:
    class { '::mq_install::...':
      ...
      logoutput => true,
      ...
    }

Default value: `'on_failure'`

## Defined types

### <a name="mq_installautostart"></a>`mq_install::autostart`

mq_install::autostart

make sure it is restarted after a system reboot.

The simples way to use it is:

``` puppet
mq_install::autostart{'QM1':}
```

Here is an example with all possible properties used:

``` puppet
mq_install::autostart{'QM1':
    path         => '/etc/systemd/system',
    service_name => 'my_mq,
    mq_version   => 8,
    mq_user      => 'mqm_user',
    mq_group     => 'mqm_group',
    nofile_limit => 20480,
    nproc_limit  => 4096,
}
```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `mq_install::autostart` defined type:

* [`ensure`](#ensure)
* [`standby`](#standby)
* [`title`](#title)
* [`path`](#path)
* [`service_name`](#service_name)
* [`mq_version`](#mq_version)
* [`mq_user`](#mq_user)
* [`mq_group`](#mq_group)
* [`nofile_limit`](#nofile_limit)
* [`nproc_limit`](#nproc_limit)
* [`multi_instance`](#multi_instance)
* [`unit_template`](#unit_template)

##### <a name="ensure"></a>`ensure`

Data type: `Enum['present', 'absent']`

Whether you want to ensure or remove the autostart.

Default value: `'present'`

##### <a name="standby"></a>`standby`

Data type: `Boolean`

Use `true` if you want to enure the startup in standby mode.

Default value: `lookup('mq_install::autostart::standby')`

##### <a name="title"></a>`title`

The title is used to specfy the name of the queue manaer you want to ensure autostarted.
Here is an example on how to use this:
``` puppet
mq_install::autostart{'QM1':
}
```

##### <a name="path"></a>`path`

Data type: `String[1]`

Allows you to specify the path where the unit-file will be placed.
Here is an example on how to use this:
``` puppet
mq_install::autostart{'QM1':
  ...
  path         => '/etc/mysystemd/system',
  ...
}
```
The default value is `/etc/systemd/system'.

Default value: `lookup('mq_install::autostart::path')`

##### <a name="service_name"></a>`service_name`

Data type: `String[1]`

Allows you to specfy the name of the service.
Here is an example on how to use this:
``` puppet
mq_install::autostart{'QM1':
  ...
  service_name => 'my_mq,
  ...
}
```
The default value is : `"mq@$queuemanager_name`.

Default value: `lookup('mq_install::autostart::service_name')`

##### <a name="mq_version"></a>`mq_version`

Data type: `Integer`

Allows you to specify the MQ versions.
At this point in time it is only used for comments in the unit.
Here is an example on how to use this:
``` puppet
mq_install::autostart{'QM1':
  ...
  mq_version   => 8,
  ...
}
```

Default value: `lookup('mq_install::autostart::mq_version')`

##### <a name="mq_user"></a>`mq_user`

Data type: `String[1]`

Allows you to specify the OS user the queue manage will be started under.
Here is an example on how to use this:
``` puppet
mq_install::autostart{'QM1':
  ...
  mq_user      => 'mqm_user',
  ...
}
```
The default value is `mqm` and is correct in most situations.

Default value: `lookup('mq_install::autostart::mq_user')`

##### <a name="mq_group"></a>`mq_group`

Data type: `String[1]`

Allows you to specify the OS group the queue manage will be started under.
Here is an example on how to use this:
``` puppet
mq_install::autostart{'QM1':
  ...
  mq_group     => 'mqm_group',
  ...
}
```
The default value is `mqm` and is correct in most situations.

Default value: `lookup('mq_install::autostart::mq_group')`

##### <a name="nofile_limit"></a>`nofile_limit`

Data type: `Integer`

The nofile limit used for the process running the queue manager.
Here is an example on how to use this:
``` puppet
mq_install::autostart{'QM1':
  ...
  nofile_limit => 20480,
  ...
}
```

Default value: `lookup('mq_install::os::nofile')`

##### <a name="nproc_limit"></a>`nproc_limit`

Data type: `Integer`

The nproc limit used for the process running the queue manager.
Here is an example on how to use this:
``` puppet
mq_install::autostart{'QM1':
  path         => '/etc/systemd/system',
  service_name => 'my_mq,
  mq_version   => 8,
  mq_user      => 'mqm_user',
  mq_group     => 'mqm_group',
  nofile_limit => 20480,
  nproc_limit  => 4096,
}
```

Default value: `lookup('mq_install::os::nproc')`

##### <a name="multi_instance"></a>`multi_instance`

Data type: `Boolean`

When `true` the queue manager wll be started in multi instance mode.
Here is an example on how to use this:
``` puppet
mq_install::autostart{'QM1':
  ...
  multi_instance => true,
  ...
}
```

Default value: `lookup('mq_install::autostart::multi_instance')`

##### <a name="unit_template"></a>`unit_template`

Data type: `String[1]`

The name of the epp template to use for the systemd unit file.
The default value is: `mq_install/mq.service.epp`.
Here is an example on how to use this:
``` puppet
mq_install::autostart{'QM1':
  ...
  unit_template => 'my_module/my_template.epp',
  ...
}
```
The template is called with these parameters:
```
'mq_version'     => $mq_version,
'mq_user'        => $mq_user,
'mq_group'       => $mq_group,
'nofile_limit'   => $nofile_limit,
'nproc_limit'    => $nproc_limit,
'multi_instance' => $multi_instance,
'standby'        => $standby,
```

Default value: `lookup('mq_install::autostart::unit_template')`

### <a name="mq_installsoftwareunix"></a>`mq_install::software::unix`

mq_install::software::unix

This is an internal defined type and should not be used by client code.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `mq_install::software::unix` defined type:

* [`source_location`](#source_location)
* [`service_window`](#service_window)
* [`version`](#version)
* [`tmp_dir`](#tmp_dir)
* [`file_name`](#file_name)
* [`selected_components`](#selected_components)
* [`logoutput`](#logoutput)

##### <a name="source_location"></a>`source_location`

Data type: `String[1]`

The location of the MQ software.
Here is an example on how to use this:
    class { '::mq_install::...':
      ...
      source_location => '/software',
      ...
    }

##### <a name="service_window"></a>`service_window`

Data type: `String[1]`

The service_window Puppet will use to execute a specified upgrade.
When Puppet detects a mismatch between the current version and the version in your manifest, it will start to execute an upgrade. But in
general, you want some control over when that happens. You don't want Puppet to stop your queue managers during regular production hours to do the upgrade.
The `service_window` parameter allows this control. The parameter can have the following values:
- DIRECT
- INSTALL_ONLY
- A time range
## DIRECT
`DIRECT` is the normal behavior of Puppet (e.g., **not** the default of the parameter). When a manifest change is detected, Puppet will immediately execute the upgrade and, in this process, stop the MQ queue managers.
## INSTALL_ONLY
This is the default value for this class. In this case, Puppet will use the specified manifest values **ONLY** on an initial install. When Puppet detects MQ is already running, it will leave it like it is and **NOT** do the upgrade. You can use, for example, a bolt plan or task to execute the upgrade at a moment that suits your requirements.
## time range
When you have a specific service window wherein Puppet **is** allowed to do the MQ shutdown and execute the upgrade procedure, you can specify a time range. An example of a time range would be: '01:00 - 02:00`

##### <a name="version"></a>`version`

Data type: `Pattern[/\d+\.\d+\.\d+\.\d/]`

The version to be installed.
Here is an example on how to use this:
    class { '::mq_install::software':
      ...
      version => '9.0.0.0',
      ...
    }

##### <a name="tmp_dir"></a>`tmp_dir`

Data type: `String[1]`

This defined type uses a temporary directory.
By default this is `\tmp`. If you want to use an other directory for this, you must specify this parameter.
Here is an example on how to use this:
    class { '::mq_install::...':
      ...
      tmp_dir => '/my_tmp_dir',
      ...
    }
On systems with a secured `/tmp` direcory, you MUST specify the `tmp_dir` parameter and specify a directory that puppet is allowed to execute scripts from. It must also have enough space to receive the extracted MQ installation kit.

Default value: `'/tmp'`

##### <a name="file_name"></a>`file_name`

Data type: `String[1]`

The file containing the install kit for the MQ software.

##### <a name="selected_components"></a>`selected_components`

Data type: `Array[String[1]]`

The components that the user has selected to be installed or updated.

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[Enum['on_failure'], Boolean]`

If you want to see the output of the `exec` resources in the type, you can set this value to `true`.
The default is `on_failure`.
Here is an example on how to use this:
    class { '::mq_install::...':
      ...
      logoutput => true,
      ...
    }

Default value: `'on_failure'`

### <a name="mq_installsoftwarewindows"></a>`mq_install::software::windows`

mq_install::software::windows

This is an internal defined type and should not be used by client code.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `mq_install::software::windows` defined type:

* [`source_location`](#source_location)
* [`version`](#version)
* [`tmp_dir`](#tmp_dir)
* [`selected_components`](#selected_components)
* [`service_window`](#service_window)
* [`file_name`](#file_name)
* [`logoutput`](#logoutput)

##### <a name="source_location"></a>`source_location`

Data type: `String`

The location of the MQ software.
Here is an example on how to use this:
    class { '::mq_install::...':
      ...
      source_location => '/software',
      ...
    }

##### <a name="version"></a>`version`

Data type: `Pattern[/\d+\.\d+\.\d+\.\d/]`

The version to be installed.
Here is an example on how to use this:
    class { '::mq_install::software':
      ...
      version => '9.0.0.0',
      ...
    }

##### <a name="tmp_dir"></a>`tmp_dir`

Data type: `String`

This defined type uses a temporary directory.
By default this is `\tmp`. If you want to use an other directory for this, you must specify this parameter.
Here is an example on how to use this:
    class { '::mq_install::...':
      ...
      tmp_dir => '/my_tmp_dir',
      ...
    }
On systems with a secured `/tmp` direcory, you MUST specify the `tmp_dir` parameter and specify a directory that puppet is allowed to execute scripts from. It must also have enough space to receive the extracted MQ installation kit.

Default value: `'C:\\tmp'`

##### <a name="selected_components"></a>`selected_components`

Data type: `Array[String[1]]`

The components that the user has selected to be installed or updated.

##### <a name="service_window"></a>`service_window`

Data type: `String[1]`

The service_window Puppet will use to execute a specified upgrade.
When Puppet detects a mismatch between the current version and the version in your manifest, it will start to execute an upgrade. But in
general, you want some control over when that happens. You don't want Puppet to stop your queue managers during regular production hours to do the upgrade.
The `service_window` parameter allows this control. The parameter can have the following values:
- DIRECT
- INSTALL_ONLY
- A time range
## DIRECT
`DIRECT` is the normal behavior of Puppet (e.g., **not** the default of the parameter). When a manifest change is detected, Puppet will immediately execute the upgrade and, in this process, stop the MQ queue managers.
## INSTALL_ONLY
This is the default value for this class. In this case, Puppet will use the specified manifest values **ONLY** on an initial install. When Puppet detects MQ is already running, it will leave it like it is and **NOT** do the upgrade. You can use, for example, a bolt plan or task to execute the upgrade at a moment that suits your requirements.
## time range
When you have a specific service window wherein Puppet **is** allowed to do the MQ shutdown and execute the upgrade procedure, you can specify a time range. An example of a time range would be: '01:00 - 02:00`

##### <a name="file_name"></a>`file_name`

Data type: `String`

The file containing the install kit for the MQ software.

Default value: `'IBM_MQ_9.1_WINDOWS_TRIAL.zip'`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[Enum['on_failure'], Boolean]`

If you want to see the output of the `exec` resources in the type, you can set this value to `true`.
The default is `on_failure`.
Here is an example on how to use this:
    class { '::mq_install::...':
      ...
      logoutput => true,
      ...
    }

Default value: `'on_failure'`

## Resource types

### <a name="mq_install"></a>`mq_install`

Setup the MQ installer.

#### Properties

The following properties are available in the `mq_install` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `mq_install` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `mq_install` resource. You will seldom need to specify this --- Puppet will usually
discover the appropriate provider for your platform.

## Functions

### <a name="mq_installfixpack_downgrade"></a>`mq_install::fixpack_downgrade`

Type: Ruby 4.x API

Function to determine if we need a fixpack downgrade. We do this based
on the current version and the requested version

#### `mq_install::fixpack_downgrade(String $current_version, String $requested_version)`

Function to determine if we need a fixpack downgrade. We do this based
on the current version and the requested version

Returns: `Boolean` If current_version is higher than the requested version return true. Else false

##### `current_version`

Data type: `String`

The currently installed fixpack version.

##### `requested_version`

Data type: `String`

The requested fixpack version.

### <a name="mq_installfixpack_upgrade"></a>`mq_install::fixpack_upgrade`

Type: Ruby 4.x API

Function to determine if we need a fixpack upgrade. We do this based
on the current version and the requested version

#### `mq_install::fixpack_upgrade(String $current_version, String $requested_version)`

Function to determine if we need a fixpack upgrade. We do this based
on the current version and the requested version

Returns: `Boolean` If current_version is lower than the requested version return true. Else false

##### `current_version`

Data type: `String`

The currently installed fixpack version.

##### `requested_version`

Data type: `String`

The requested fixpack version.

### <a name="mq_installrunning_managers"></a>`mq_install::running_managers`

Type: Ruby 4.x API

Function to fetch the fact mq_managers and based on that information
decide if the specfied queue manager is running in standby mode or not.

#### `mq_install::running_managers()`

Function to fetch the fact mq_managers and based on that information
decide if the specfied queue manager is running in standby mode or not.

Returns: `Array` The MQ manageres that are currently running on the system

### <a name="mq_installselected_components"></a>`mq_install::selected_components`

Type: Ruby 4.x API

Create array of selected components based on the selection.

rubocop:disable all

#### `mq_install::selected_components(String $version, Hash $supported_components, Boolean $install_ams, Boolean $install_ft, Boolean $install_client, Boolean $install_explorer, Boolean $install_xrserver, Boolean $install_samples, Boolean $install_sdk, Boolean $install_man, Boolean $install_gskit, Boolean $install_amqp, Boolean $install_web, Boolean $install_salesforce, Boolean $install_blockchain, Boolean $install_rdqm, Boolean $install_toolkit)`

Create array of selected components based on the selection.

rubocop:disable all

Returns: `Any` List of selected compinents based on selection

##### `version`

Data type: `String`

The version of MQ installed

##### `supported_components`

Data type: `Hash`

COmponents supported on this type of system

##### `install_ams`

Data type: `Boolean`

Install component ams

##### `install_ft`

Data type: `Boolean`

Install component ft

##### `install_client`

Data type: `Boolean`

Install component client

##### `install_explorer`

Data type: `Boolean`

Install component explorer

##### `install_xrserver`

Data type: `Boolean`

Install component xrserver

##### `install_samples`

Data type: `Boolean`

Install component samples

##### `install_sdk`

Data type: `Boolean`

Install component sdk

##### `install_man`

Data type: `Boolean`

Install component man

##### `install_gskit`

Data type: `Boolean`

Install component gskit

##### `install_amqp`

Data type: `Boolean`

Install component amqp

##### `install_web`

Data type: `Boolean`

Install component web

##### `install_salesforce`

Data type: `Boolean`

Install component salesforce

##### `install_blockchain`

Data type: `Boolean`

Install component blockchain

##### `install_rdqm`

Data type: `Boolean`

Install component rdqm

##### `install_toolkit`

Data type: `Boolean`

Install component toolkit

### <a name="mq_installvalidate_selection"></a>`mq_install::validate_selection`

Type: Ruby 4.x API

Fetch the OS specifc settings and validate if the selected components can be installed here.

rubocop:disable all

#### `mq_install::validate_selection(Hash $supported_components, Boolean $install_ams, Boolean $install_ft, Boolean $install_client, Boolean $install_explorer, Boolean $install_xrserver, Boolean $install_samples, Boolean $install_sdk, Boolean $install_man, Boolean $install_gskit, Boolean $install_amqp, Boolean $install_web, Boolean $install_salesforce, Boolean $install_blockchain, Boolean $install_rdqm, Boolean $install_toolkit)`

Fetch the OS specifc settings and validate if the selected components can be installed here.

rubocop:disable all

Returns: `Any` Nothing

##### `supported_components`

Data type: `Hash`

COmponents supported on this type of system

##### `install_ams`

Data type: `Boolean`

Install component ams

##### `install_ft`

Data type: `Boolean`

Install component ft

##### `install_client`

Data type: `Boolean`

Install component client

##### `install_explorer`

Data type: `Boolean`

Install component explorer

##### `install_xrserver`

Data type: `Boolean`

Install component xrserver

##### `install_samples`

Data type: `Boolean`

Install component samples

##### `install_sdk`

Data type: `Boolean`

Install component sdk

##### `install_man`

Data type: `Boolean`

Install component man

##### `install_gskit`

Data type: `Boolean`

Install component gskit

##### `install_amqp`

Data type: `Boolean`

Install component amqp

##### `install_web`

Data type: `Boolean`

Install component web

##### `install_salesforce`

Data type: `Boolean`

Install component salesforce

##### `install_blockchain`

Data type: `Boolean`

Install component blockchain

##### `install_rdqm`

Data type: `Boolean`

Install component rdqm

##### `install_toolkit`

Data type: `Boolean`

Install component toolkit

### <a name="mq_installversion_upgrade"></a>`mq_install::version_upgrade`

Type: Ruby 4.x API

Function to determine if we are changing to version with a different major or minor version.

#### `mq_install::version_upgrade(String $current_version, String $requested_version)`

Function to determine if we are changing to version with a different major or minor version.

Returns: `Boolean` If current_version is higher major version than the requested version return true. Else false

##### `current_version`

Data type: `String`

The currently installed MQ version.

##### `requested_version`

Data type: `String`

The requested MQ version.

## Tasks

### <a name="restart"></a>`restart`

Restart the specified MQ queue manager on the specified node

**Supports noop?** false

#### Parameters

##### `queue_manager`

Data type: `Optional[String[1]]`

name of the queue manager

### <a name="start"></a>`start`

Startup the specified MQ queue manager on the specified node

**Supports noop?** false

#### Parameters

##### `queue_manager`

Data type: `Optional[String[1]]`

name of the queue manager

### <a name="status"></a>`status`

Fetch the status of the specified MQ queue manager on the specified node

**Supports noop?** false

#### Parameters

##### `queue_manager`

Data type: `Optional[String[1]]`

name of the queue manager

### <a name="stop"></a>`stop`

Shutdown the specified MQ queue manager on the specified node

**Supports noop?** false

#### Parameters

##### `queue_manager`

Data type: `Optional[String[1]]`

name of the queue manager

## Plans

### <a name="mq_installapply_fixpack"></a>`mq_install::apply_fixpack`

See the file "LICENSE" for the full license governing this code.

++--++
This bolt plan applies the pending MQ software updates specified in the hieradata, to the nodes that are targeted.

## How does it work

It applies the puppet class `mq_install::fixpack` to the named targets.Because the service window is set to
DIRECT, applying the upgrade will start immediately.

If the any MQ managers are running, they will be stopped before applying the MQ fixpack. After the fickpack is done
The plan will restart any queue managers that were started before the start of the plan.

## Take care

This puppet plan expects a prerequisite that all of the values for the `mq_install::fixpack` class are resolvable
through hiera. If this is not the case, the puppet plan will fail, citing that it cannot find one of the parameters.

The best way is to use the same hiera config for this puppet task as the hiera config you use for regular puppet runs. Take care, however that
hiera in bolt/puppet plans  cannot access trusted facts in the hiera config.

--++--

#### Examples

##### 

```puppet

bolt --hiera_config /etc/puppetlabs/code/environments/production/hiera.yaml --modulepath /etc/puppetlabs/code/environments/production/modules/ plan run mq_install::apply_fixpack --targets server1,server2
```

#### Parameters

The following parameters are available in the `mq_install::apply_fixpack` plan:

* [`targets`](#targets)

##### <a name="targets"></a>`targets`

Data type: `TargetSpec`

The MQ node(s) you want to apply a software update to

### <a name="mq_installapply_upgrades"></a>`mq_install::apply_upgrades`

See the file "LICENSE" for the full license governing this code.

++--++
This bolt plan applies the pending MQ software updates specified in the hieradata, to the nodes that are targeted.

## How does it work

It applies the puppet class `mq_install::software` to the named targets.Because the service window is set to
DIRECT, applying the upgrade will start immediately.

If the any MQ managers are running, they will be stopped before applying the MQ upgrade. After the upgrade is done
The plan will restart any queue managers that were started before the start of the plan.

## Take care

This puppet plan expects a prerequisite that all of the values for the `mq_install::software` class are resolvable
through hiera. If this is not the case, the puppet plan will fail, citing that it cannot find one of the parameters.

The best way is to use the same hiera config for this puppet task as the hiera config you use for regular puppet runs. Take care, however that
hiera in bolt/puppet plans  cannot access trusted facts in the hiera config.

--++--

#### Examples

##### 

```puppet

bolt --hiera_config /etc/puppetlabs/code/environments/production/hiera.yaml --modulepath /etc/puppetlabs/code/environments/production/modules/ plan run mq_install::apply_upgrades --targets server1,server2
```

#### Parameters

The following parameters are available in the `mq_install::apply_upgrades` plan:

* [`targets`](#targets)

##### <a name="targets"></a>`targets`

Data type: `TargetSpec`

The MQ node(s) you want to apply a software update to

