#
# See the file "LICENSE" for the full license governing this code.
#
#
# Get all installed MQ packages in windows version.
#
Facter.add(:mq_installed_components) do
  confine :kernel => 'windows'
  setcode do
    next [] if Facter.value(:mq_version) == 'not-installed'

    map = {
      'Development' => 'Toolkit',
      'Local' => 'Client'
    }
    output = Facter::Util::Resolution.exec('reg query HKLM\\Software\\Ibm\\MQSeries\\CurrentVersion\\Components')
    components = output.split("\n").collect { |r| r.split[0] }[1, 99]
    components.map do |component|
      if map.key?(component)
        map[component]
      else
        component
      end
    end
  end
end

Facter.add(:mq_installed_components) do
  confine :kernel => 'AIX'
  setcode do
    next [] if Facter.value(:mq_version) == 'not-installed'

    Facter::Util::Resolution.exec("lslpp -l | grep mqm | awk '{print $1}'").split
  end
end

Facter.add(:mq_installed_components) do
  confine :kernel => 'SunOS'
  setcode do
    next [] if Facter.value(:mq_version) == 'not-installed'

    remove = %w[none Cs_CZ De_DE Es_ES Fr_FR Hu_HU It_IT Ja_JP Ko_KR Pl_PL Pt_BR Ru_RU Zh_CN Zh_TW]
    Facter::Util::Resolution.exec('pkgparam mqm CLASSES').split - remove
  end
end

Facter.add(:mq_installed_components) do
  confine :kernel => 'Linux'
  setcode do
    next [] if Facter.value(:mq_version) == 'not-installed'

    output = Facter::Util::Resolution.exec('rpm -qa | grep MQSeries')
    output.scan(/(MQSeries.*?)-/).flatten.uniq
  end
end
