#
# See the file "LICENSE" for the full license governing this code.
#
#
# Get MQ version information, and parse the version number.
#
Facter.add(:mq_version) do
  confine :kernel => 'windows'

  setcode do
    cmd_out = Facter::Util::Resolution.exec('reg query HKLM\\Software\\Ibm\\MQSeries\\CurrentVersion /v VRMF')
    if cmd_out.to_s.empty?
      'not-installed'
    else
      result = cmd_out.scan(/VRMF    REG_SZ\s*(.*)/)[0][0]
      if result.to_s.empty?
        'not-installed'
      else
        result
      end
    end
  end
end

Facter.add(:mq_version) do
  confine :kernel => %w[Linux AIX SunOS]

  setcode do
    mq_path = Facter.value(:mq_path)
    if File.exist?("#{mq_path}/bin/setmqenv")
      info = Facter::Util::Resolution.exec("#{mq_path}/bin/dspmqver")
      begin
        info.scan(/Version:\s*(.*)/)[0][0]
      rescue NoMethodError
        'invalid-version'
      end
    else
      'not-installed'
    end
  end
end
