#
# Function to fetch the fact mq_managers and based on that information
# decide if the specfied queue manager is running in standby mode or not.
#
Puppet::Functions.create_function('mq_install::running_managers') do
  #
  # See the file "LICENSE" for the full license governing this code.
  #
  # @return The MQ manageres that are currently running on the system
  #
  dispatch :running_managers do
    return_type 'Array'
  end

  def running_managers
    variable = 'mq_managers'
    running_qms = []
    if variable_exists?(variable)
      fact_value = closure_scope.lookupvar("::#{variable}")
      fact_value.each { |qm| running_qms << qm['name'] if qm['state'] == 'Running' }
    end
    running_qms
  end

  # Check if the variable exists without generating a warning
  def variable_exists?(var)
    closure_scope.to_hash.key?(var)
  end
end
